# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define section         free
%define namedversion    4.1-alpha3-SNAPSHOT
%define sname    httpclient

Name:           hc-httpclient
Version:        4.1
Release:        0.r962552.1%{?dist}
Epoch:          0
Summary:        HTTPClient components
License:        Apache Software License 2.0
Url:            http://hc.apache.org/
Group:          Development/Libraries/Java
Source0:        hc-httpclient-4.1-r962552.tgz
# svn export http://svn.apache.org/repos/asf/httpcomponents/httpclient/trunk/ hc-httpclient-4.1/
# tar czf hc-httpclient-4.1-r962552.tgz hc-httpclient-4.1/


Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        jakarta-httpcomponents-pom.xml
#Source4:        apache-jar-resource-bundle-1.3.jar

Patch0:         %{name}-httpmime-pom.patch
Patch1:         %{name}-cache-pom.patch
Patch2:         %{name}-pom.patch


BuildRequires:  jpackage-utils >= 0:5.0.0
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  easymock-classextension2
BuildRequires:  hc-httpcore
BuildRequires:  junit >= 0:3.8.2
%if %{with_maven}
BuildRequires:  maven2 >= 2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven-release
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  docbkx
BuildRequires:  felix-maven2
%endif
Requires:  java >= 0:1.6.0
Requires:  hc-httpcore
Requires(post):    jpackage-utils >= 0:5.0.0
Requires(postun):  jpackage-utils >= 0:5.0.0
%if %{gcj_support}
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif
Provides:       jakarta-httpcore = %{epoch}:%{version}-%{release}
Obsoletes:      jakarta-httpcore < %{epoch}:%{version}-%{release}

%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot

%description
The Hyper-Text Transfer Protocol (HTTP) is perhaps the most
significant protocol used on the Internet today. Web services,
network-enabled appliances and the growth of network computing
continue to expand the role of the HTTP protocol beyond
user-driven web browsers, while increasing the number of
applications that require HTTP support.

Although the java.net package provides basic functionality
for accessing resources via HTTP, it doesn't provide the full
flexibility or functionality needed by many applications.
HttpClient seeks to fill this void by providing an efficient,
up-to-date, and feature-rich package implementing the client
side of the most recent HTTP standards and recommendations.

Designed for extension while providing robust support for the
base HTTP protocol, HttpClient may be of interest to anyone
building HTTP-aware client applications such as web browsers,
web service clients, or systems that leverage or extend the
HTTP protocol for distributed communication.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q
cp %{SOURCE1} settings.xml
mkdir -p .m2/repository/org/apache/httpcomponents/project/4.0/
cp %{SOURCE3} .m2/repository/org/apache/httpcomponents/project/4.0/project-4.0.pom
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2

%build
%if %{with_maven}
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
#mkdir -p $MAVEN_REPO_LOCAL/org.apache/
#cp %{SOURCE4} $MAVEN_REPO_LOCAL/org.apache/apache-jar-resource-bundle.jar

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dmaven.test.failure.ignore=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install

mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Daggregate=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        javadoc:javadoc

%else
ant -Djunit.jar=$(build-classpath junit) \
     package test javadoc
%endif


%install
rm -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/httpcomponents
%if %{with_maven}
install -m 644 httpmime/target/httpmime-%{namedversion}.jar \
       $RPM_BUILD_ROOT%{_javadir}/httpcomponents/httpmime-%{version}.jar
install -m 644 %{sname}-cache/target/%{sname}-cache-%{namedversion}.jar \
       $RPM_BUILD_ROOT%{_javadir}/httpcomponents/%{sname}-cache-%{version}.jar
install -m 644 %{sname}/target/%{sname}-%{namedversion}.jar \
       $RPM_BUILD_ROOT%{_javadir}/httpcomponents/%{sname}-%{version}.jar
install -m 644 %{sname}/target/%{sname}-%{namedversion}-tests.jar \
       $RPM_BUILD_ROOT%{_javadir}/httpcomponents/%{sname}-tests-%{version}.jar
install -m 644 %{sname}-osgi/target/org.apache.httpcomponents.httpclient_%{namedversion}.jar \
       $RPM_BUILD_ROOT%{_javadir}/httpcomponents/org.apache.httpcomponents.httpclient_%{version}.jar
%else
install -m 644 dist/%{name}-SNAPSHOT.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 dist/%{name}-nio-SNAPSHOT.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}-nio-%{version}.jar
install -m 644 dist/%{name}-niossl-SNAPSHOT.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}-niossl-%{version}.jar
%endif

(cd $RPM_BUILD_ROOT%{_javadir}/httpcomponents && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 %{SOURCE3} \
$RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.httpcomponents-project.pom
%add_to_maven_depmap org.apache.httpcomponents project 4.0 JPP/httpcomponents project

install -m 644 pom.xml \
$RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.httpcomponents-client.pom
%add_to_maven_depmap org.apache.httpcomponents httpcomponents-client %{namedversion} JPP/httpcomponents client
install -m 644 httpmime/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.httpcomponents-httpmime.pom
%add_to_maven_depmap org.apache.httpcomponents httpmime %{namedversion} JPP/httpcomponents httpmime
install -m 644 httpclient/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.httpcomponents-httpclient.pom
%add_to_maven_depmap org.apache.httpcomponents httpclient %{namedversion} JPP/httpcomponents httpclient
install -m 644 httpclient-cache/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.httpcomponents-httpclient-cache.pom
%add_to_maven_depmap org.apache.httpcomponents httpclient-cache %{namedversion} JPP/httpcomponents httplient-cache

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%if %{with_maven}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%else
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%endif
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink


%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap 
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif


%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/httpcomponents
%{_javadir}/httpcomponents/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-*%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Sat Sep 18 2010 Ralph Apel <r.apel at r-apel.de> 0:4.1-0.r962552.1
- 4.1 alpha3 SNAPSHOT

* Thu Mar 26 2009 Ralph Apel <r.apel at r-apel.de> 0:4.0-1.jpp5
- 4.0 final

* Mon Feb 02 2009 Ralph Apel <r.apel at r-apel.de> 0:4.0-0.a5.1.jpp5
- 4.0-alpha5
- rename from jakarta-httpcore to hc-httpcore
- Obsolete and Provide jakarta-httpcore
- Include compat symlinks
- Build -niossl library

* Wed May 23 2007 Ralph Apel <r.apel at r-apel.de> 0:4.0-0.a4.1jpp
- Initial build.

